const mockUser = {
  active: 1,
  deleted: 0,
  email: 'rking@backtrace.io',
  method: 'password',
  role: 'admin',
  superuser: 0,
  uid: 32,
  universe: 1,
  username: 'rking',
};

const mockSuperuser = {
  active: 1,
  deleted: 0,
  email: 'rking@backtrace.io',
  method: 'password',
  role: 'admin',
  superuser: 1,
  uid: 32,
  universe: 1,
  username: 'rking',
};

const request = (requestParams, requestBody) => {
  return new Promise((res, rej) => {
    process.nextTick(() => {
      switch (requestParams.path) {
        case '/api/saml':
          try {
            const body = JSON.parse(requestBody);
            if (body.form.email === 'rking@backtrace.io') {
              res({
                response: {
                  token: 'this-is-a-token',
                },
              });
            } else {
              rej(new Error('no such user'));
            }
          } catch (err) {
            rej(err);
          }
          break;
        case '/api/config':
          if (requestParams.host) {
            if (
              requestParams.headers &&
              requestParams.headers &&
              (requestParams.headers['X-Coroner-Token'] === 'test-token' ||
                requestParams.headers['X-Coroner-Token'] ===
                  'test-token-superuser')
            ) {
              requestParams.headers['X-Coroner-Token'] === 'test-token'
                ? res({ user: mockUser })
                : res({ user: mockSuperuser });
            } else {
              rej(new Error('invalid token'));
            }
          } else {
            rej(new Error('malformed request'));
          }
          break;
        default:
          rej(new Error('Something went wrong'));
      }
    });
  });
};

module.exports = request;
