const https = require('https');
const axios = require('axios');
const { service } = require('./service-layer');

const httpsAgent = service.identityManager.descr.isOnPremise
  ? new https.Agent({ rejectUnauthorized: false })
  : https.globalAgent;

function coronerLogin(coronerdUrl, email, token) {
  const prefix = coronerdUrl.endsWith('/') ? '' : '/';
  const requestUrl = `${coronerdUrl}${prefix}api/saml`;

  const data = {
    action: 'login',
    form: {
      email,
    },
    token,
  };

  return axios.post(requestUrl, data, {
    httpsAgent,
    headers: {
      'Content-Type': 'application/json',
    },
  });
}

module.exports = coronerLogin;
